package com.ibm.db2.app;

import java.io.*;
import java.io.ByteArrayInputStream;
import java.sql.Date;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;

public class  JavaTransformUDF extends COM.ibm.db2.app.UDF {

   static private String _debugFileName=null;
   static {
      String userHome=System.getProperty("ibm.db2.instance.path");
      _debugFileName=userHome+java.io.File.separator+"udfDebug";
   }


protected static void trace(String msg)  {
   try {
      java.io.FileOutputStream _debugFileOS=new java.io.FileOutputStream(_debugFileName,true);
      java.io.PrintStream _debugFilePW=new java.io.PrintStream(_debugFileOS);

      _debugFilePW.println(msg);

      _debugFilePW.close();
      _debugFileOS.close();
   } catch (Exception e) { }
}
   
   

	public void getType(COM.ibm.db2.app.Blob b, String type) throws Exception {
	  byte buffer[]=null;
	  String className=null;
	  int in=b.getInputStream().available();
	  buffer=new byte[in];
	  b.getInputStream().read(buffer);

	  ByteArrayInputStream bin=new ByteArrayInputStream(buffer);
   
	  DataInputStream din=new DataInputStream(bin);
	  if ( (din.readUnsignedByte()==0xAC) &&  (din.readUnsignedByte()==0xED)  // magic number
		   && (din.readUnsignedByte()==0x00) &&  (din.readUnsignedByte()==0x05)   // version
		   && (din.readUnsignedByte()==0x73) &&  (din.readUnsignedByte()==0x72)) {  // TC_OBJECT TC_CLASSDESC
			className=din.readUTF();         
			set(2,className);
	  }

	  din.close();
	  bin.close();      
   }   

	static public Object readFromBlob(COM.ibm.db2.app.Blob b, String expectedClassName) throws Exception {
	Object o=null;
	byte buffer[]=null;
	int in=b.getInputStream().available();
	buffer=new byte[in];
	
	b.getInputStream().read(buffer);
	ByteArrayInputStream bin=new ByteArrayInputStream(buffer);
	bin.mark(in);
	DataInputStream din=new DataInputStream(bin);
	if ( (din.readUnsignedByte()==0xAC) &&  (din.readUnsignedByte()==0xED)  // magic number
	     && (din.readUnsignedByte()==0x00) &&  (din.readUnsignedByte()==0x05)   // version
	     && (din.readUnsignedByte()==0x73) &&  (din.readUnsignedByte()==0x72)) {  // TC_OBJECT TC_CLASSDESC
	    String className=din.readUTF();
		if (!className.equals(expectedClassName)) {
		bin.close();
		din.close();
		return null;
	    }
	}

	din.close();
	bin.reset();
	ObjectInputStream oin= new ObjectInputStream(bin);
	o=oin.readObject();
	if (o == null) {
	    throw new Exception("Error in stream");
	}
	return o;
	}


	public Object readSerialized(InputStream in) throws Exception {
		ObjectInputStream oin= new ObjectInputStream(in);
		return oin.readObject();
	}


// converter functions to convert between the UDF string
	// representation and the JDBC types
	// DATE: yyyy-mm-dd 
	// TIME: hh.mm.ss
	// TIMESTAMP: yyyy-mm-dd-hh.mm.ss.nnnnnn
protected Calendar toCalendar(String s) {
	if (s==null) return null;
	java.util.StringTokenizer st=new java.util.StringTokenizer(s,"-");
	if (st.countTokens()!=3) {
		return null;
	}
	int years=Integer.parseInt(st.nextToken());
	int month=Integer.parseInt(st.nextToken());
	int day=Integer.parseInt(st.nextToken());
	Calendar cal=Calendar.getInstance();
	cal.set(years-1900,month-1,day); 
	return cal;
	}
	
// converter functions to convert between the UDF string
	// representation and the JDBC types
	// DATE: yyyy-mm-dd 
	// TIME: hh.mm.ss
	// TIMESTAMP: yyyy-mm-dd-hh.mm.ss.nnnnnn
protected Date toDate(String s) {
	if (s==null) return null;
	java.util.StringTokenizer st=new java.util.StringTokenizer(s,"-");
	if (st.countTokens()!=3) {
		return null;
	}
	int years=Integer.parseInt(st.nextToken());
	int month=Integer.parseInt(st.nextToken());
	int day=Integer.parseInt(st.nextToken());
	return new Date(years-1900,month-1,day); 
	}

	
	// converter functions to convert between the UDF string
	// representation and the JDBC types
	// DATE: yyyy-mm-dd 
	// TIME: hh.mm.ss
	// TIMESTAMP: yyyy-mm-dd-hh.mm.ss.nnnnnn

	protected String toISOString(Date d) {
		if (d==null) return null;
		java.util.Date ud=new java.util.Date(d.getTime());
		Calendar c= Calendar.getInstance();
		c.setTime(ud);
		StringBuffer sb=new StringBuffer(10);
		sb.append(c.get(Calendar.YEAR));

		sb.append('-');
		int month=c.get(Calendar.MONTH)+1;
		if (month<10) sb.append("0");
		sb.append(month);
		
		sb.append('-');
		int day=c.get(Calendar.DAY_OF_MONTH);
		if (day<10) sb.append("0");
		sb.append(day);
		
		return sb.toString();
	}


	protected String toISOString(Time t) {
		if (t==null) return null;
		StringBuffer sb=new StringBuffer(8);
		java.util.Date d=new java.util.Date(t.getTime());
		Calendar c= Calendar.getInstance();
		c.setTime(d);

      int hour= c.get(Calendar.HOUR_OF_DAY);
      if (hour<10) {
         sb.append("0");
      }
		sb.append(hour);         
		sb.append('.');

      int minute=c.get(Calendar.MINUTE);
      if (minute<10) {
         sb.append("0");
      }
		sb.append(minute);              
		sb.append('.');

      int second=c.get(Calendar.SECOND);
      if (second<10) {
         sb.append("0");
      }
		sb.append(second);
		
		return sb.toString();
	}


	protected String toISOString(Timestamp ts) {
		if (ts==null) return null;
		java.util.Date d=new java.util.Date(ts.getTime());
		Calendar c= Calendar.getInstance();
		c.setTime(d);
		StringBuffer sb=new StringBuffer(26);
		sb.append(c.get(Calendar.YEAR));
		
		sb.append('-');
		int month=c.get(Calendar.MONTH)+1;
		if (month<10) sb.append("0");
		sb.append(month);
		
		sb.append('-');
		int day=c.get(Calendar.DAY_OF_MONTH);
		if (day<10) sb.append("0");
		sb.append(day);
		
		sb.append('-');
		int hour=c.get(Calendar.HOUR_OF_DAY);
		if (hour<10) sb.append("0");
		sb.append(hour);
		
		sb.append('.');
		int min=c.get(Calendar.MINUTE);
		if (min<10) sb.append("0");
		sb.append(min);
		
		sb.append('.');
		int sec=c.get(Calendar.SECOND);
		if (sec<10) sb.append("0");
		sb.append(sec);
		
		sb.append('.');		
		int nan=ts.getNanos();
		sb.append(nan);
		
		return sb.toString(); 
	 } 
	 
	 	// converter functions to convert between the UDF string
	// representation and the JDBC types
	// DATE: yyyy-mm-dd 
	// TIME: hh.mm.ss
	// TIMESTAMP: yyyy-mm-dd-hh.mm.ss.nnnnnn
	// CALENDAR: yyyy-mm-dd

	protected String toISOString(Calendar c) {
		StringBuffer sb=new StringBuffer(10);
		sb.append(c.get(Calendar.YEAR));

		sb.append('-');
		int month=c.get(Calendar.MONTH)+1;
		if (month<10) sb.append("0");
		sb.append(month);
		
		sb.append('-');
		int day=c.get(Calendar.DAY_OF_MONTH);
		if (day<10) sb.append("0");
		sb.append(day);

		return sb.toString();
	}

	 
// converter functions to convert between the UDF string
	// representation and the JDBC types
	// DATE: yyyy-mm-dd 
	// TIME: hh.mm.ss
	// TIMESTAMP: yyyy-mm-dd-hh.mm.ss.nnnnnn
protected Time toTime(String s) {
		if (s==null) return null;
		java.util.StringTokenizer st=new java.util.StringTokenizer(s,".");
		if (st.countTokens()!=3) {
			return null;
		}
		int hours=Integer.parseInt(st.nextToken());
		int minutes=Integer.parseInt(st.nextToken());
		int seconds=Integer.parseInt(st.nextToken());
		return new Time(hours,minutes,seconds);
	}


// converter functions to convert between the UDF string
// representation and the JDBC types
// DATE: yyyy-mm-dd 
// TIME: hh.mm.ss
// TIMESTAMP: yyyy-mm-dd-hh.mm.ss.nnnnnn
protected Timestamp toTimestamp(String s) {
		if (s==null) return null;					
		java.util.StringTokenizer st=new java.util.StringTokenizer(s,"-.");

		if (st.countTokens()!=7) {
			return null;
		}
		int years=Integer.parseInt(st.nextToken());
		int month=Integer.parseInt(st.nextToken());
		int day=Integer.parseInt(st.nextToken());

		int hours=Integer.parseInt(st.nextToken());
		int minutes=Integer.parseInt(st.nextToken());
		int seconds=Integer.parseInt(st.nextToken());
		int nanos=Integer.parseInt(st.nextToken());
		return new Timestamp(years-1900,month-1,day,hours,minutes,seconds,nanos);
	}


	public void writeSerialized(java.sql.SQLOutput so, Object o) throws Exception {
		// TBD: improve this! toByteArray actually copies the bytes from os...
		
		ByteArrayOutputStream os=new ByteArrayOutputStream();
		ObjectOutputStream oos=new ObjectOutputStream(os);
		oos.writeObject(o);
		oos.flush();
		ByteArrayInputStream is=new ByteArrayInputStream(os.toByteArray());
		so.writeBinaryStream(is);
		oos.close();
		os.close();
		is.close();

	}


static public void writeToBlob(Object o, COM.ibm.db2.app.Blob resultBlob) throws Exception {
	OutputStream os=resultBlob.getOutputStream();
	ObjectOutputStream oos=new ObjectOutputStream(os);
	oos.writeObject(o);
	oos.flush();
	oos.close();
	os.close();
	}
}
