# CONTAINS com.ibm.etools.application

#####################################################################
#
# Sed command for replacing references to MOF2 APIs
# invoke using
#    sed -f j2ee.sed <src-file> > <target-file>
#
#####################################################################

# Rules for converting APIs from the ApplicationPackage package
s|metaWebModule()\.lookupFeature(\([^)]*\))|EcoreHelper.getEFeatureId((EFeature)\1,ApplicationPackage.WEB_MODULE,ApplicationPackage.packageURI)|g
s|metaModule()\.lookupFeature(\([^)]*\))|EcoreHelper.getEFeatureId((EFeature)\1,ApplicationPackage.MODULE,ApplicationPackage.packageURI)|g
s|metaApplication()\.lookupFeature(\([^)]*\))|EcoreHelper.getEFeatureId((EFeature)\1,ApplicationPackage.APPLICATION,ApplicationPackage.packageURI)|g
s|ApplicationPackage\.CLASS_WEBMODULE|ApplicationPackage.WEB_MODULE|g
s|ApplicationPackage\.CLASS_MODULE|ApplicationPackage.MODULE|g
s|ApplicationPackage\.CLASS_JAVACLIENTMODULE|ApplicationPackage.JAVA_CLIENT_MODULE|g
s|ApplicationPackage\.CLASS_EJBMODULE|ApplicationPackage.EJB_MODULE|g
s|ApplicationPackage\.CLASS_CONNECTORMODULE|ApplicationPackage.CONNECTOR_MODULE|g
s|ApplicationPackage\.CLASS_APPLICATION|ApplicationPackage.APPLICATION|g
s|ApplicationFactory\.CLASS_WEBMODULE|ApplicationPackage.WEB_MODULE|g
s|ApplicationFactory\.CLASS_MODULE|ApplicationPackage.MODULE|g
s|ApplicationFactory\.CLASS_JAVACLIENTMODULE|ApplicationPackage.JAVA_CLIENT_MODULE|g
s|ApplicationFactory\.CLASS_EJBMODULE|ApplicationPackage.EJB_MODULE|g
s|ApplicationFactory\.CLASS_CONNECTORMODULE|ApplicationPackage.CONNECTOR_MODULE|g
s|ApplicationFactory\.CLASS_APPLICATION|ApplicationPackage.APPLICATION|g
s|\.meta\.MetaWebModule\.|.MetaWebModule.|g
s|\.meta\.MetaModule\.|.MetaModule.|g
s|\.meta\.MetaJavaClientModule\.|.MetaJavaClientModule.|g
s|\.meta\.MetaEjbModule\.|.MetaEjbModule.|g
s|\.meta\.MetaConnectorModule\.|.MetaConnectorModule.|g
s|\.meta\.MetaApplication\.|.MetaApplication.|g
s|metaWebModule()\.metaUri()|ePackageApplication().getModule_Uri()|g
s|metaWebModule()\.metaContextRoot()|ePackageApplication().getWebModule_ContextRoot()|g
s|metaWebModule()\.metaApplication()|ePackageApplication().getModule_Application()|g
s|metaWebModule()\.metaAltDD()|ePackageApplication().getModule_AltDD()|g
s|metaModule()\.metaUri()|ePackageApplication().getModule_Uri()|g
s|metaModule()\.metaApplication()|ePackageApplication().getModule_Application()|g
s|metaModule()\.metaAltDD()|ePackageApplication().getModule_AltDD()|g
s|metaJavaClientModule()\.metaUri()|ePackageApplication().getModule_Uri()|g
s|metaJavaClientModule()\.metaApplication()|ePackageApplication().getModule_Application()|g
s|metaJavaClientModule()\.metaAltDD()|ePackageApplication().getModule_AltDD()|g
s|metaEjbModule()\.metaUri()|ePackageApplication().getModule_Uri()|g
s|metaEjbModule()\.metaApplication()|ePackageApplication().getModule_Application()|g
s|metaEjbModule()\.metaAltDD()|ePackageApplication().getModule_AltDD()|g
s|metaConnectorModule()\.metaUri()|ePackageApplication().getModule_Uri()|g
s|metaConnectorModule()\.metaApplication()|ePackageApplication().getModule_Application()|g
s|metaConnectorModule()\.metaAltDD()|ePackageApplication().getModule_AltDD()|g
s|metaApplication()\.metaSmallIcon()|ePackageApplication().getApplication_SmallIcon()|g
s|metaApplication()\.metaSecurityRoles()|ePackageApplication().getApplication_SecurityRoles()|g
s|metaApplication()\.metaModules()|ePackageApplication().getApplication_Modules()|g
s|metaApplication()\.metaLargeIcon()|ePackageApplication().getApplication_LargeIcon()|g
s|metaApplication()\.metaDisplayName()|ePackageApplication().getApplication_DisplayName()|g
s|metaApplication()\.metaDescription()|ePackageApplication().getApplication_Description()|g
s|com\.ibm\.etools\.application\.meta\.MetaWebModule|com.ibm.etools.emf.ecore.EClass|g
s|com\.ibm\.etools\.application\.meta\.MetaModule|com.ibm.etools.emf.ecore.EClass|g
s|com\.ibm\.etools\.application\.meta\.MetaJavaClientModule|com.ibm.etools.emf.ecore.EClass|g
s|com\.ibm\.etools\.application\.meta\.MetaEjbModule|com.ibm.etools.emf.ecore.EClass|g
s|com\.ibm\.etools\.application\.meta\.MetaConnectorModule|com.ibm.etools.emf.ecore.EClass|g
s|com\.ibm\.etools\.application\.meta\.MetaApplication|com.ibm.etools.emf.ecore.EClass|g
s|MetaWebModule\.SF_URI|ApplicationPackage.WEB_MODULE__URI|g
s|MetaWebModule\.SF_CONTEXTROOT|ApplicationPackage.WEB_MODULE__CONTEXT_ROOT|g
s|MetaWebModule\.SF_APPLICATION|ApplicationPackage.WEB_MODULE__APPLICATION|g
s|MetaWebModule\.SF_ALTDD|ApplicationPackage.WEB_MODULE__ALT_DD|g
s|MetaModule\.SF_URI|ApplicationPackage.MODULE__URI|g
s|MetaModule\.SF_APPLICATION|ApplicationPackage.MODULE__APPLICATION|g
s|MetaModule\.SF_ALTDD|ApplicationPackage.MODULE__ALT_DD|g
s|MetaJavaClientModule\.SF_URI|ApplicationPackage.JAVA_CLIENT_MODULE__URI|g
s|MetaJavaClientModule\.SF_APPLICATION|ApplicationPackage.JAVA_CLIENT_MODULE__APPLICATION|g
s|MetaJavaClientModule\.SF_ALTDD|ApplicationPackage.JAVA_CLIENT_MODULE__ALT_DD|g
s|MetaEjbModule\.SF_URI|ApplicationPackage.EJB_MODULE__URI|g
s|MetaEjbModule\.SF_APPLICATION|ApplicationPackage.EJB_MODULE__APPLICATION|g
s|MetaEjbModule\.SF_ALTDD|ApplicationPackage.EJB_MODULE__ALT_DD|g
s|MetaConnectorModule\.SF_URI|ApplicationPackage.CONNECTOR_MODULE__URI|g
s|MetaConnectorModule\.SF_APPLICATION|ApplicationPackage.CONNECTOR_MODULE__APPLICATION|g
s|MetaConnectorModule\.SF_ALTDD|ApplicationPackage.CONNECTOR_MODULE__ALT_DD|g
s|MetaApplication\.SF_SMALLICON|ApplicationPackage.APPLICATION__SMALL_ICON|g
s|MetaApplication\.SF_SECURITYROLES|ApplicationPackage.APPLICATION__SECURITY_ROLES|g
s|MetaApplication\.SF_MODULES|ApplicationPackage.APPLICATION__MODULES|g
s|MetaApplication\.SF_LARGEICON|ApplicationPackage.APPLICATION__LARGE_ICON|g
s|MetaApplication\.SF_DISPLAYNAME|ApplicationPackage.APPLICATION__DISPLAY_NAME|g
s|MetaApplication\.SF_DESCRIPTION|ApplicationPackage.APPLICATION__DESCRIPTION|g
/MetaWebModule metaWebModule/!s|MetaWebModule\([^a-zA-Z0-9]\)|EClass\1|g
/MetaModule metaModule/!s|MetaModule\([^a-zA-Z0-9]\)|EClass\1|g
/MetaJavaClientModule metaJavaClientModule/!s|MetaJavaClientModule\([^a-zA-Z0-9]\)|EClass\1|g
/MetaEjbModule metaEjbModule/!s|MetaEjbModule\([^a-zA-Z0-9]\)|EClass\1|g
/MetaConnectorModule metaConnectorModule/!s|MetaConnectorModule\([^a-zA-Z0-9]\)|EClass\1|g
/MetaApplication metaApplication/!s|MetaApplication\([^a-zA-Z0-9]\)|EClass\1|g
s|\.metaUri()|.getEFeature(ApplicationPackage.MODULE__URI,ApplicationPackage.MODULE,ApplicationPackage.packageURI)|g
s|\.metaSmallIcon()|.getEFeature(ApplicationPackage.APPLICATION__SMALL_ICON,ApplicationPackage.APPLICATION,ApplicationPackage.packageURI)|g
s|\.metaSecurityRoles()|.getEFeature(ApplicationPackage.APPLICATION__SECURITY_ROLES,ApplicationPackage.APPLICATION,ApplicationPackage.packageURI)|g
s|\.metaModules()|.getEFeature(ApplicationPackage.APPLICATION__MODULES,ApplicationPackage.APPLICATION,ApplicationPackage.packageURI)|g
s|\.metaLargeIcon()|.getEFeature(ApplicationPackage.APPLICATION__LARGE_ICON,ApplicationPackage.APPLICATION,ApplicationPackage.packageURI)|g
s|\.metaDisplayName()|.getEFeature(ApplicationPackage.APPLICATION__DISPLAY_NAME,ApplicationPackage.APPLICATION,ApplicationPackage.packageURI)|g
s|\.metaDescription()|.getEFeature(ApplicationPackage.APPLICATION__DESCRIPTION,ApplicationPackage.APPLICATION,ApplicationPackage.packageURI)|g
s|\.metaContextRoot()|.getEFeature(ApplicationPackage.WEB_MODULE__CONTEXT_ROOT,ApplicationPackage.WEB_MODULE,ApplicationPackage.packageURI)|g
s|\.metaApplication()|.getEFeature(ApplicationPackage.MODULE__APPLICATION,ApplicationPackage.MODULE,ApplicationPackage.packageURI)|g
s|\.metaAltDD()|.getEFeature(ApplicationPackage.MODULE__ALT_DD,ApplicationPackage.MODULE,ApplicationPackage.packageURI)|g
/MetaWebModule metaWebModule/!s|metaWebModule()|eClassWebModule()|g
/MetaModule metaModule/!s|metaModule()|eClassModule()|g
/MetaJavaClientModule metaJavaClientModule/!s|metaJavaClientModule()|eClassJavaClientModule()|g
/MetaEjbModule metaEjbModule/!s|metaEjbModule()|eClassEjbModule()|g
/MetaConnectorModule metaConnectorModule/!s|metaConnectorModule()|eClassConnectorModule()|g
/MetaApplication metaApplication/!s|metaApplication()|eClassApplication()|g

