# CONTAINS com.ibm.etools.java

#####################################################################
#
# Sed command for replacing references to MOF2 APIs
# invoke using
#    sed -f JavaRef.sed <src-file> > <target-file>
#
#####################################################################

# Rules for converting APIs from the JavaRefPackage package
s|MetaArrayType\.SF_EPACKAGE|JavaRefPackage.ARRAY_TYPE__E_PACKAGE|g
s|MetaArrayType\.SF_EOBJECTCONTAINS|JavaRefPackage.ARRAY_TYPE__E_OBJECT_CONTAINS|g
s|MetaArrayType\.SF_EOBJECTCONTAINER|JavaRefPackage.ARRAY_TYPE__E_OBJECT_CONTAINER|g
s|MetaArrayType\.SF_ENAMESPACECONTAINER|JavaRefPackage.ARRAY_TYPE__E_NAMESPACE_CONTAINER|g
s|MetaArrayType\.SF_ENAMEDELEMENTS|JavaRefPackage.ARRAY_TYPE__E_NAMED_ELEMENTS|g
s|MetaArrayType\.SF_EMETAOBJ|JavaRefPackage.ARRAY_TYPE__E_META_OBJ|g
s|MetaArrayType\.SF_EID|JavaRefPackage.ARRAY_TYPE__EID|g
s|MetaArrayType\.SF_EDECORATORS|JavaRefPackage.ARRAY_TYPE__E_DECORATORS|g
s|MetaArrayType\.SF_ECONTAINS|JavaRefPackage.ARRAY_TYPE__E_CONTAINS|g
s|MetaArrayType\.SF_ECONTAINER|JavaRefPackage.ARRAY_TYPE__E_CONTAINER|g
s|MetaArrayType\.SF_EBEHAVIORS|JavaRefPackage.ARRAY_TYPE__E_BEHAVIORS|g
s|MetaArrayType\.SF_EATTRIBUTES|JavaRefPackage.ARRAY_TYPE__E_ATTRIBUTES|g
s|MetaArrayType\.SF_EALLREFERENCES|JavaRefPackage.ARRAY_TYPE__E_ALL_REFERENCES|g
s|MetaArrayType\.SF_EALLCONTAINMENTS|JavaRefPackage.ARRAY_TYPE__E_ALL_CONTAINMENTS|g
s|MetaArrayType\.SF_EALLBEHAVIORS|JavaRefPackage.ARRAY_TYPE__E_ALL_BEHAVIORS|g
s|MetaArrayType\.SF_EALLATTRIBUTES|JavaRefPackage.ARRAY_TYPE__E_ALL_ATTRIBUTES|g
s|MetaArrayType\.SF_DECLARINGCLASS|JavaRefPackage.ARRAY_TYPE__DECLARING_CLASS|g
s|MetaArrayType\.SF_DECLAREDCLASSES|JavaRefPackage.ARRAY_TYPE__DECLARED_CLASSES|g
s|MetaArrayType\.SF_CONSTRAINTS|JavaRefPackage.ARRAY_TYPE__CONSTRAINTS|g
s|MetaArrayType\.SF_COMPONENTTYPE|JavaRefPackage.ARRAY_TYPE__COMPONENT_TYPE|g
s|MetaArrayType\.SF_CLASSIMPORT|JavaRefPackage.ARRAY_TYPE__CLASS_IMPORT|g
s|MetaArrayType\.SF_ARRAYDIMENSIONS|JavaRefPackage.ARRAY_TYPE__ARRAY_DIMENSIONS|g
s|MetaArrayType\.SF_ALLEVENTS|JavaRefPackage.ARRAY_TYPE__ALL_EVENTS|g
/MetaTypeKind metaTypeKind/!s|MetaTypeKind\([^a-zA-Z0-9]\)|EEnum\1|g
/MetaStatement metaStatement/!s|MetaStatement\([^a-zA-Z0-9]\)|EClass\1|g
/MetaMethod metaMethod/!s|MetaMethod\([^a-zA-Z0-9]\)|EClass\1|g
/MetaJavaVisibilityKind metaJavaVisibilityKind/!s|MetaJavaVisibilityKind\([^a-zA-Z0-9]\)|EEnum\1|g
/MetaJavaParameter metaJavaParameter/!s|MetaJavaParameter\([^a-zA-Z0-9]\)|EClass\1|g
/MetaJavaParameterKind metaJavaParameterKind/!s|MetaJavaParameterKind\([^a-zA-Z0-9]\)|EEnum\1|g
/MetaJavaPackage metaJavaPackage/!s|MetaJavaPackage\([^a-zA-Z0-9]\)|EClass\1|g
/MetaJavaEvent metaJavaEvent/!s|MetaJavaEvent\([^a-zA-Z0-9]\)|EClass\1|g
/MetaJavaDataType metaJavaDataType/!s|MetaJavaDataType\([^a-zA-Z0-9]\)|EClass\1|g
/MetaJavaClass metaJavaClass/!s|MetaJavaClass\([^a-zA-Z0-9]\)|EClass\1|g
/MetaInitializer metaInitializer/!s|MetaInitializer\([^a-zA-Z0-9]\)|EClass\1|g
/MetaField metaField/!s|MetaField\([^a-zA-Z0-9]\)|EClass\1|g
/MetaComment metaComment/!s|MetaComment\([^a-zA-Z0-9]\)|EClass\1|g
/MetaBlock metaBlock/!s|MetaBlock\([^a-zA-Z0-9]\)|EClass\1|g
/MetaArrayType metaArrayType/!s|MetaArrayType\([^a-zA-Z0-9]\)|EClass\1|g
s|\.metaSource()|.getEFeature(JavaRefPackage.METHOD__SOURCE,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaParameters()|.getEFeature(JavaRefPackage.METHOD__PARAMETERS,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaParameterKind()|.getEFeature(JavaRefPackage.JAVA_PARAMETER__PARAMETER_KIND,JavaRefPackage.JAVA_PARAMETER,JavaRefPackage.packageURI)|g
s|\.metaPackageImports()|.getEFeature(JavaRefPackage.JAVA_CLASS__PACKAGE_IMPORTS,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaName()|.getEFeature(JavaRefPackage.BLOCK__NAME,JavaRefPackage.BLOCK,JavaRefPackage.packageURI)|g
s|\.metaMethods()|.getEFeature(JavaRefPackage.JAVA_CLASS__METHODS,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaKind()|.getEFeature(JavaRefPackage.JAVA_CLASS__KIND,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaJavaVisibility()|.getEFeature(JavaRefPackage.METHOD__JAVA_VISIBILITY,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaJavaPackage()|.getEFeature(JavaRefPackage.JAVA_CLASS__JAVA_PACKAGE,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaJavaExceptions()|.getEFeature(JavaRefPackage.METHOD__JAVA_EXCEPTIONS,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaJavaClasses()|.getEFeature(JavaRefPackage.JAVA_PACKAGE__JAVA_CLASSES,JavaRefPackage.JAVA_PACKAGE,JavaRefPackage.packageURI)|g
s|\.metaJavaClass()|.getEFeature(JavaRefPackage.METHOD__JAVA_CLASS,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaIsSynchronized()|.getEFeature(JavaRefPackage.METHOD__IS_SYNCHRONIZED,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaIsStatic()|.getEFeature(JavaRefPackage.METHOD__IS_STATIC,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaIsPublic()|.getEFeature(JavaRefPackage.JAVA_CLASS__IS_PUBLIC,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaIsNative()|.getEFeature(JavaRefPackage.METHOD__IS_NATIVE,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaIsFinal()|.getEFeature(JavaRefPackage.METHOD__IS_FINAL,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaIsConstructor()|.getEFeature(JavaRefPackage.METHOD__IS_CONSTRUCTOR,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaIsAbstract()|.getEFeature(JavaRefPackage.METHOD__IS_ABSTRACT,JavaRefPackage.METHOD,JavaRefPackage.packageURI)|g
s|\.metaInitializers()|.getEFeature(JavaRefPackage.JAVA_CLASS__INITIALIZERS,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaInitializer()|.getEFeature(JavaRefPackage.FIELD__INITIALIZER,JavaRefPackage.FIELD,JavaRefPackage.packageURI)|g
s|\.metaImplementsInterfaces()|.getEFeature(JavaRefPackage.JAVA_CLASS__IMPLEMENTS_INTERFACES,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaFields()|.getEFeature(JavaRefPackage.JAVA_CLASS__FIELDS,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaEvents()|.getEFeature(JavaRefPackage.JAVA_CLASS__EVENTS,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaDeclaringClass()|.getEFeature(JavaRefPackage.JAVA_CLASS__DECLARING_CLASS,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaDeclaredClasses()|.getEFeature(JavaRefPackage.JAVA_CLASS__DECLARED_CLASSES,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaContents()|.getEFeature(JavaRefPackage.BLOCK__CONTENTS,JavaRefPackage.BLOCK,JavaRefPackage.packageURI)|g
s|\.metaComponentType()|.getEFeature(JavaRefPackage.ARRAY_TYPE__COMPONENT_TYPE,JavaRefPackage.ARRAY_TYPE,JavaRefPackage.packageURI)|g
s|\.metaClassImport()|.getEFeature(JavaRefPackage.JAVA_CLASS__CLASS_IMPORT,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
s|\.metaArrayDimensions()|.getEFeature(JavaRefPackage.ARRAY_TYPE__ARRAY_DIMENSIONS,JavaRefPackage.ARRAY_TYPE,JavaRefPackage.packageURI)|g
s|\.metaAllEvents()|.getEFeature(JavaRefPackage.JAVA_CLASS__ALL_EVENTS,JavaRefPackage.JAVA_CLASS,JavaRefPackage.packageURI)|g
/MetaStatement metaStatement/!s|metaStatement()|eClassStatement()|g
/MetaMethod metaMethod/!s|metaMethod()|eClassMethod()|g
/MetaJavaParameter metaJavaParameter/!s|metaJavaParameter()|eClassJavaParameter()|g
/MetaJavaPackage metaJavaPackage/!s|metaJavaPackage()|eClassJavaPackage()|g
/MetaJavaEvent metaJavaEvent/!s|metaJavaEvent()|eClassJavaEvent()|g
/MetaJavaDataType metaJavaDataType/!s|metaJavaDataType()|eClassJavaDataType()|g
/MetaJavaClass metaJavaClass/!s|metaJavaClass()|eClassJavaClass()|g
/MetaInitializer metaInitializer/!s|metaInitializer()|eClassInitializer()|g
/MetaField metaField/!s|metaField()|eClassField()|g
/MetaComment metaComment/!s|metaComment()|eClassComment()|g
/MetaBlock metaBlock/!s|metaBlock()|eClassBlock()|g
/MetaArrayType metaArrayType/!s|metaArrayType()|eClassArrayType()|g








